3 # Copyright (c) 2005 Junio C Hamano
6 # For repeatability, reset the environment to known value.
11 export LANG LC_ALL PAGER TZ
17 unset COMMIT_AUTHOR_EMAIL
18 unset COMMIT_AUTHOR_NAME
19 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
21 GIT_AUTHOR_EMAIL=author@example.com
22 GIT_AUTHOR_NAME='A U Thor'
23 unset GIT_COMMITTER_DATE
24 GIT_COMMITTER_EMAIL=committer@example.com
25 GIT_COMMITTER_NAME='C O Mitter'
28 unset GIT_EXTERNAL_DIFF
30 unset GIT_OBJECT_DIRECTORY
31 unset SHA1_FILE_DIRECTORIES
32 unset SHA1_FILE_DIRECTORY
34 export GIT_MERGE_VERBOSITY
35 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
36 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
39 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
41 echo "* warning: Some tests will not work if GIT_TRACE" \
42 "is set as to trace on STDERR ! *"
43 echo "* warning: Please set GIT_TRACE to something" \
44 "other than 1, 2 or true ! *"
48 # Each test should start with something like this, after copyright notices:
50 # test_description='Description of this test...
51 # This test checks if command xyzzy does the right thing...
65 test "${test_description}" != "" ||
66 error "Test script did not set test_description."
71 -d|--d|--de|--deb|--debu|--debug)
73 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
75 -h|--h|--he|--hel|--help)
76 echo "$test_description"
78 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
89 if test "$verbose" = "t"
93 exec 4>/dev/null 3>/dev/null
99 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
102 if test -z "${test_tick+set}"
106 test_tick=$(($test_tick + 60))
108 GIT_COMMITTER_DATE="$test_tick -0700"
109 GIT_AUTHOR_DATE="$test_tick -0700"
110 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
113 # You are not expected to call test_ok_ and test_failure_ directly, use
114 # the text_expect_* functions instead.
117 test_count=$(expr "$test_count" + 1)
118 say " ok $test_count: $@"
122 test_count=$(expr "$test_count" + 1)
123 test_failure=$(expr "$test_failure" + 1);
124 say "FAIL $test_count: $1"
126 echo "$@" | sed -e 's/^/ /'
127 test "$immediate" = "" || { trap - exit; exit 1; }
132 test "$debug" = "" || eval "$1"
142 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
143 this_test="$this_test.$(expr "$test_count" + 1)"
145 for skp in $GIT_SKIP_TESTS
154 say >&3 "skipping test: $@"
155 test_count=$(expr "$test_count" + 1)
156 say "skip $test_count: $1"
165 test_expect_failure () {
167 error "bug in the test script: not 2 parameters to test-expect-failure"
170 say >&3 "expecting failure: $2"
172 if [ "$?" = 0 -a "$eval_ret" != 0 -a "$eval_ret" -lt 129 ]
182 test_expect_success () {
184 error "bug in the test script: not 2 parameters to test-expect-success"
187 say >&3 "expecting success: $2"
189 if [ "$?" = 0 -a "$eval_ret" = 0 ]
199 test_expect_code () {
201 error "bug in the test script: not 3 parameters to test-expect-code"
204 say >&3 "expecting exit code $1: $3"
206 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
216 # Most tests can use the created repository, but some amy need to create more.
217 # Usage: test_create_repo <directory>
218 test_create_repo () {
220 error "bug in the test script: not 1 parameter to test-create-repo"
224 cd "$repo" || error "Cannot setup test environment"
225 "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
226 error "cannot run git init -- have you built things yet?"
227 mv .git/hooks .git/hooks-disabled
233 case "$test_failure" in
236 # cd .. && rm -fr trash
237 # but that means we forbid any tests that use their own
238 # subdirectory from calling test_done without coming back
239 # to where they started from.
240 # The Makefile provided will clean this test area so
241 # we will leave things as they are.
243 say "passed all $test_count test(s)"
247 say "failed $test_failure among $test_count test(s)"
253 # Test the binaries we have just built. The tests are kept in
254 # t/ subdirectory and are run in trash subdirectory.
256 GIT_EXEC_PATH=$(pwd)/..
257 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
258 GIT_CONFIG=.git/config
259 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG
261 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
263 test -d ../templates/blt || {
264 error "You haven't built things yet, have you?"
267 if ! test -x ../test-chmtime; then
268 echo >&2 'You need to build test-chmtime:'
269 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
276 test_create_repo $test
279 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
280 for skp in $GIT_SKIP_TESTS
283 for skp in $GIT_SKIP_TESTS
292 say >&3 "skipping test $this_test altogether"
293 say "skip all tests in $this_test"